Index: branches/src/ProcessManagement/ProcessManagement/Forms/SubForms/FrmRequestPrint.cs
===================================================================
--- branches/src/ProcessManagement/ProcessManagement/Forms/SubForms/FrmRequestPrint.cs	(revision 59)
+++ branches/src/ProcessManagement/ProcessManagement/Forms/SubForms/FrmRequestPrint.cs	(revision 60)
@@ -53,6 +53,7 @@
         enum enumSheetName
         {
             Cover = 0,
+            List,
             Detail,
         }
 
@@ -62,11 +63,13 @@
         private static readonly Dictionary<enumSheetName,string> s_DicSheetName = new Dictionary<enumSheetName, string>()
         {
             { enumSheetName.Cover, "請求書（表紙）" },
+            { enumSheetName.List, "請求書（一覧）" },
             { enumSheetName.Detail, "請求書（内訳）" },
         };
         #endregion
 
         #region 変数
+
         /// <summary>
         /// 終了状態フラグ
         /// </summary>
@@ -125,7 +128,7 @@
         /// <summary>
         /// 請求合計データ
         /// </summary>
-        private List<RequestTotalData> m_LstRequestTotalData = new List<RequestTotalData>();
+//        private List<RequestTotalData> m_LstRequestTotalData = new List<RequestTotalData>();
 
         /// <summary>
         /// ツールチップ
@@ -147,6 +150,28 @@
         /// </summary>
         private int m_SelectOrderIndex = 0;
 
+        /// <summary>
+        /// 請求書No
+        /// </summary>
+        private int m_nInvoiceNo = 0;
+
+        /// <summary>
+        /// 請求書データ
+        /// </summary>
+        private InvoiceData m_InvData = new InvoiceData();
+
+        /// <summary>
+        /// 請求書ヘッダ
+        /// </summary>
+        private List<RequestHead> m_lstReqHead = new List<RequestHead>();
+
+        /// <summary>
+        /// 請求書データ
+        /// </summary>
+        private Dictionary<int, List<RequestData>> m_dicReqData = new Dictionary<int, List<RequestData>>();
+
+        private Dictionary<int, ConstructionBaseInfo> m_dicConstructionBaseInfo = new Dictionary<int, ConstructionBaseInfo>();
+        
         // *-----* 共通処理設定 *-----*
         /// <summary>
         /// サブフォームフラグ
@@ -200,6 +225,15 @@
             set { m_bDatePrintFlg = value; }
         }
 
+        /// <summary>
+        /// 設計書No
+        /// </summary>
+        public int InvoiceNo
+        {
+            get { return m_nInvoiceNo; }
+            set { m_nInvoiceNo = value; }
+        }
+
         // *-----* 共通処理設定 *-----*
         /// <summary>
         /// サブフォームフラグ
@@ -288,16 +322,21 @@
             if (!StatusChange()) return;
 
             // 日付印刷をしない
-            if (radioButton3.Checked) m_bDatePrintFlg = false;
+            if (rdNoPrint.Checked) m_bDatePrintFlg = false;
 
             // 選択日付取得
             m_ExcuteDate = dateTimePicker1.Value;
 
-            // 工事基本情報を更新する
-            UpdateConstructionBaseInfo();
+            // 請求書データの反映
+            EntryInvoiceData();
 
-            // 非同期で印刷処理を実行する
-            m_SelectOrderIndex = cmbOrderNo.SelectedIndex;
+            // 工事の進捗状態に「変更する」が選択されている場合
+            if (rdChange.Checked)
+            {
+                // 工事基本情報を更新する
+                UpdateConstructionBaseInfo();
+            }
+
             await Task.Run(() =>
             {
                 // 印刷処理
@@ -320,7 +359,7 @@
             // 保存先指定ダイアログの表示
             FrmSaveFilePath frm = new FrmSaveFilePath();
             frm.SaveType = (int)CommonDefine.SaveFileType.ExcelFile;
-            frm.ShowDialog();
+            frm.ShowDialog(this);
             if (frm.EndButton == DialogResult.Cancel)
             {
                 return;
@@ -331,16 +370,22 @@
             if (!StatusChange()) return;
 
             // 日付印刷をしない
-            if (radioButton3.Checked) m_bDatePrintFlg = false;
+            if (rdNoPrint.Checked) m_bDatePrintFlg = false;
             
             // 選択日付取得
             m_ExcuteDate = dateTimePicker1.Value;
 
-            // 工事基本情報を更新する
-            UpdateConstructionBaseInfo();
+            // 請求書データの反映
+            EntryInvoiceData();
 
+            // 工事の進捗状態に「変更する」が選択されている場合
+            if (rdChange.Checked)
+            {
+                // 工事基本情報を更新する
+                UpdateConstructionBaseInfo();
+            }
+
             // 非同期で印刷処理を実行する
-            m_SelectOrderIndex = cmbOrderNo.SelectedIndex;
             await Task.Run(() =>
             {
                 // 印刷処理
@@ -360,7 +405,7 @@
         /// <param name="e"></param>
         private void radioButton3_CheckedChanged(object sender, EventArgs e)
         {
-            if (radioButton3.Checked)
+            if (rdNoPrint.Checked)
             {
                 dateTimePicker1.Visible = false;
             }
@@ -380,13 +425,23 @@
         private void radioButton1_CheckedChanged(object sender, EventArgs e)
         {
             // 工事進捗変更
-            if (radioButton1.Checked)
-            {   // 変更する
-                m_dispControl[(int)Dispcount.ProgressStatusB].Text = CommonDefine.ProjectsStatus[m_ProgressStatus];
+            if (rdChange.Checked)
+            {
+                lblNowState.Enabled = true;
+                lblChgState.Enabled = true;
+                lblProgressNameA.Enabled = true;
+                lblProgressNameB.Enabled = true;
+                lblGuide.Enabled = true;
+                lblArrow.Enabled = true;
             }
             else
-            {   // 変更しない
-                m_dispControl[(int)Dispcount.ProgressStatusB].Text = CommonDefine.ProjectsStatus[m_ConstructionBaseInfo.ConstructionStatusFlg];
+            {
+                lblNowState.Enabled = false;
+                lblChgState.Enabled = false;
+                lblProgressNameA.Enabled = false;
+                lblProgressNameB.Enabled = false;
+                lblGuide.Enabled = false;
+                lblArrow.Enabled = false;
             }
         }
         #endregion
@@ -400,10 +455,10 @@
             m_dispControl[(int)Dispcount.ExeCuteDate] = dateTimePicker1;
             m_dispControl[(int)Dispcount.ProgressStatusA] = lblProgressNameA;
             m_dispControl[(int)Dispcount.ProgressStatusB] = lblProgressNameB;
-            m_dispControl[(int)Dispcount.radioButtonA1] = radioButton1;
-            m_dispControl[(int)Dispcount.radioButtonA2] = radioButton2;
-            m_dispControl[(int)Dispcount.radioButtonB1] = radioButton4;
-            m_dispControl[(int)Dispcount.radioButtonB2] = radioButton3;
+            m_dispControl[(int)Dispcount.radioButtonA1] = rdChange;
+            m_dispControl[(int)Dispcount.radioButtonA2] = rdNoChange;
+            m_dispControl[(int)Dispcount.radioButtonB1] = rdPrint;
+            m_dispControl[(int)Dispcount.radioButtonB2] = rdNoPrint;
         }
         #endregion
 
@@ -416,7 +471,7 @@
         {
             try
             {
-                if (!lblProgressNameA.Text.Equals(lblProgressNameB.Text))
+                if (rdChange.Checked == true)
                 {
                     if (MessageBox.Show("工事案件の進捗状態が変わります、よろしいですか？",
                                         "進捗状態変更確認",
@@ -465,103 +520,283 @@
         /// <returns></returns>
         private bool DisplayData()
         {
-            var lstReqTotalData = new List<RequestTotalData>();
-
             try
             {
                 bool bRet = true;
 
-                // 工事基本情報を取得
-                if (!GetConstructionBaseInfo(m_ConstructionCode, ref m_ConstructionBaseInfo))
-                {
+                // 請求書データの取得
+                if( GetInvoiceData() == false){
                     return false;
                 }
 
-                // 増減工事情報を取得
-                if (!GetConstructionLink(m_ConstructionCode, ref m_LstConstructionLink))
-                {
+                // 本工事の工事情報の取得
+                if( GetMainConstructionBaseInfo() == false){
                     return false;
                 }
 
-                List<int> lstConstCodes = new List<int>();
-                lstConstCodes.Add(m_ConstructionCode);
-                lstConstCodes.AddRange(m_LstConstructionLink);
-
-                // 工事基本情報明細を取得
-                if (!GetConstructionBaseInfoDetail(lstConstCodes, ref m_DicConstructionBaseInfoDetail))
+                if (m_InvData.RequestDate == DateTime.MinValue)
                 {
-                    return false;
+                    // 初期時間セット
+                    dateTimePicker1.Value = m_ExcuteDate;
                 }
+                else
+                {
+                    dateTimePicker1.Value = m_InvData.CretateDate;
+                }
 
-                // 請求データを取得
-                if (!GetRequestData(m_ConstructionCode, ref m_RequestData))
+                lblOrderersName.Text = m_InvData.RequestName;
+
+                txtComment1.Text = m_InvData.Comment1;
+                txtComment2.Text = m_InvData.Comment2;
+                txtComment3.Text = m_InvData.Comment3;
+                txtComment4.Text = m_InvData.Comment4;
+                txtComment5.Text = m_InvData.Comment5;
+
+                // ToolTipの設定
+                SetToolTip();
+
+                return bRet;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+        }
+        #endregion
+
+        #region ToolTipの設定
+        private void SetToolTip()
+        {
+            // ToolTipが表示されるまでの時間
+            ToolTip1.InitialDelay = 0;
+            // ToolTipが表示されている時に、別のToolTipを表示するまでの時間
+            ToolTip1.ReshowDelay = 1000;
+            // ToolTipを表示する時間
+            ToolTip1.AutoPopDelay = 10000;
+            // フォームがアクティブでない時はToolTipを表示しない
+            ToolTip1.ShowAlways = false;
+
+            // 文字セット
+            ToolTip1.SetToolTip(dateTimePicker1, "請求日が表示されている日付と違う場合は、変更してください。");
+            ToolTip1.SetToolTip(rdPrint, "請求日を請求書へ「印刷する」場合は、こちらを選択してください。");
+            ToolTip1.SetToolTip(rdNoPrint, "請求日を請求書へ「印刷せずに空白」で印刷する場合は、こちらを選択してください。");
+
+            ToolTip1.SetToolTip(rdChange, "工事進捗状態を変更して次の処理へ進む場合は、こちらを選択してください。");
+            ToolTip1.SetToolTip(rdNoChange, "工事進捗進捗を現在の状態から変更しない場合は、こちらを選択してください。");
+        }
+        #endregion
+
+        #region 請求書データの取得
+        /// <summary>
+        /// 請求書データの取得
+        /// </summary>
+        private bool GetInvoiceData()
+        {
+            IOInvoiceData ioInvData = new IOInvoiceData();
+            IORequestHead ioReqHead = new IORequestHead();
+            IORequestData ioReqData = new IORequestData();
+
+            try
+            {
+                string sql = "";
+
+                // 請求書データの取得
+                sql = ioInvData.CreatePrimarykeyString(m_nInvoiceNo);
+                if (ioInvData.SelectAction(sql, ref m_InvData) == false)
                 {
                     return false;
                 }
 
-                // 請求合計データを取得
-                if (!GetRequestTotalData(m_RequestNo, ref m_LstRequestTotalData))
+                // 請求ヘッダの取得
+                sql = string.Format(" WHERE InvoiceNo = {0} ORDER BY ReqConstructionCode", m_nInvoiceNo);
+                if (ioReqHead.SelectAction(sql, ref m_lstReqHead) == false)
                 {
                     return false;
                 }
 
-                // 作成対象のコンボボックスリストを初期化
-                cmbOrderNo.Items.Clear();
-                foreach (var reqTotalData in m_LstRequestTotalData)
+                foreach (RequestHead ReqHead in m_lstReqHead)
                 {
-                    // 請求回数分
-                    cmbOrderNo.Items.Add(string.Format("{0}回目", reqTotalData.OrderNo));
+                    // 請求ヘッダの取得
+                    sql = string.Format(" WHERE RequestNo = {0} ORDER BY MainConstructionCode", ReqHead.RequestNo);
+                    List<RequestData> lstReqData = new List<RequestData>();
+                    if (ioReqData.SelectAction(sql, ref lstReqData) == false)
+                    {
+                        return false;
+                    }
+
+                    m_dicReqData.Add(ReqHead.RequestNo, lstReqData);
+
                 }
-                cmbOrderNo.SelectedIndex = 0;
 
-                // 初期時間セット
-                dateTimePicker1.Value = m_ExcuteDate;
+                return true;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
 
-                // ----- 状態を工事基本情報より取る
-                // 現在進捗状態
-                m_dispControl[(int)Dispcount.ProgressStatusA].Text = CommonDefine.ProjectsStatus[m_ConstructionBaseInfo.ConstructionStatusFlg];
+                return false;
+            }
+            finally
+            {
+                ioInvData.close();
+                ioInvData = null;
+                ioReqHead.close();
+                ioReqHead = null;
+                ioReqData.close();
+                ioReqData = null;
+            }
 
-                // 実行後進捗状態
-                if (m_ConstructionBaseInfo.ConstructionStatusFlg == 8)
+        }
+        #endregion
+
+        #region 工事基本情報の追加
+        private void AddConstructionBaseInfoDic(ConstructionBaseInfo Info)
+        {
+            ConstructionBaseInfo wrk = null;
+
+            if (m_dicConstructionBaseInfo.TryGetValue(Info.ConstructionCode, out wrk) == false)
+            {
+                m_dicConstructionBaseInfo.Add(Info.ConstructionCode, Info);
+            }
+        }
+        #endregion
+
+        #region 工事基本情報の取得
+        /// <summary>
+        /// 工事基本情報の取得
+        /// </summary>
+        private bool GetMainConstructionBaseInfo()
+        {
+            IOConstructionBaseInfo ioInfo = new IOConstructionBaseInfo();
+
+            foreach (RequestHead ReqHead in m_lstReqHead)
+            {
+                string sql = ioInfo.CreatePrimarykeyString(ReqHead.ReqConstructionCode);
+                ConstructionBaseInfo info = new ConstructionBaseInfo();
+                if (ioInfo.SelectAction(sql, ref info) == false)
                 {
-                    // 現在の進捗状態が施工完了の場合
-                    radioButton1.Checked = true;
-                    m_dispControl[(int)Dispcount.ProgressStatusB].Text = CommonDefine.ProjectsStatus[m_ProgressStatus];
+                    return false;
                 }
-                else
+
+                AddConstructionBaseInfoDic(info);
+            }
+
+            List<int> lstKey = new List<int>(m_dicReqData.Keys);
+            try
+            {
+                foreach (int nRequestNo in lstKey)
                 {
-                    // 施工完了以外の場合
-                    radioButton2.Checked = true;
-                    radioButton1.Enabled = false;
-                    m_dispControl[(int)Dispcount.ProgressStatusB].Text = m_dispControl[(int)Dispcount.ProgressStatusA].Text;
+                    List<RequestData> lstReqData = null;
+
+                    if (m_dicReqData.TryGetValue(nRequestNo, out lstReqData) == false)
+                    {
+                        return false;
+                    }
+
+                    foreach (RequestData ReqData in lstReqData)
+                    {
+                        string sql = ioInfo.CreatePrimarykeyString(ReqData.MainConstructionCode);
+                        ConstructionBaseInfo info = new ConstructionBaseInfo();
+                        if (ioInfo.SelectAction(sql, ref info) == false)
+                        {
+                            return false;
+                        }
+
+                        AddConstructionBaseInfoDic(info);
+                    }
+
                 }
 
-                // ----- ToolTipの設定を行う
-                // ToolTipが表示されるまでの時間
-                ToolTip1.InitialDelay = 0;
-                // ToolTipが表示されている時に、別のToolTipを表示するまでの時間
-                ToolTip1.ReshowDelay = 1000;
-                // ToolTipを表示する時間
-                ToolTip1.AutoPopDelay = 10000;
-                // フォームがアクティブでない時はToolTipを表示しない
-                ToolTip1.ShowAlways = false;
+                return true;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
 
-                // 文字セット
-                ToolTip1.SetToolTip(dateTimePicker1, "請求日が表示されている日付と違う場合は、変更してください。");
-                ToolTip1.SetToolTip(radioButton4, "請求日を請求書へ「印刷する」場合は、こちらを選択してください。");
-                ToolTip1.SetToolTip(radioButton3, "請求日を請求書へ「印刷せずに空白」で印刷する場合は、こちらを選択してください。");
+                return false;
+            }
+            finally
+            {
+                ioInfo.close();
+                ioInfo = null;
+            }
 
-                ToolTip1.SetToolTip(radioButton1, "工事進捗状態を変更して次の処理へ進む場合は、こちらを選択してください。");
-                ToolTip1.SetToolTip(radioButton2, "工事進捗進捗を現在の状態から変更しない場合は、こちらを選択してください。");
-                
-                return bRet;
+        }
+        #endregion
+
+        #region 請求書データの反映
+        private void EntryInvoiceData()
+        {
+            int nTotalAmount = 0;
+            int nTaxAmount = 0;
+
+            foreach (RequestHead ReqHead in m_lstReqHead)
+            {
+                nTotalAmount += ReqHead.RequestTotalAmount;
+                nTaxAmount += ReqHead.TaxAmount;
             }
+
+            m_InvData.TotalAmount = nTotalAmount;
+            m_InvData.TaxAmount = nTaxAmount;
+
+            if (rdPrint.Checked == true)
+            {
+                m_InvData.CretateDate = dateTimePicker1.Value;
+            }
+            else
+            {
+                m_InvData.CretateDate = DateTime.MinValue;
+            }
+
+            m_InvData.Comment1 = txtComment1.Text;
+            m_InvData.Comment2 = txtComment2.Text;
+            m_InvData.Comment3 = txtComment3.Text;
+            m_InvData.Comment4 = txtComment4.Text;
+            m_InvData.Comment5 = txtComment5.Text;
+
+            if (rdChange.Checked == true)
+            {
+                m_InvData.CompleteFlg = 1;
+
+                if (UpdateInvoiceData() == false)
+                {
+                    return;
+                }
+            }
+
+        }
+        #endregion
+
+        #region 請求書データ更新
+        private bool UpdateInvoiceData()
+        {
+            IOInvoiceData ioInvData = new IOInvoiceData();
+
+            try
+            {
+                string sql = ioInvData.CreatePrimarykeyString( m_InvData.InvoiceNo );
+                if (ioInvData.UpdateAction(sql, m_InvData) == false)
+                {
+                    return false;
+                }
+
+                return true;
+            }
             catch (Exception ex)
             {
                 logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+
                 return false;
             }
+            finally
+            {
+                ioInvData.close();
+                ioInvData = null;
+            }
+
         }
+        
         #endregion
 
         #region 工事データ更新
@@ -571,28 +806,132 @@
         /// <returns></returns>
         private bool UpdateConstructionBaseInfo()
         {
-            var lstReqTotalData = new List<RequestTotalData>();
-            IOConstructionBaseInfo cbDB = new IOConstructionBaseInfo();
+
+            IOConstructionBaseInfo ioInfo = new IOConstructionBaseInfo();
+            IOConstructionProgressDate ioPrgDate = new IOConstructionProgressDate();
+
+            List<int> lstKeyInfo = new List<int>(m_dicConstructionBaseInfo.Keys);
+
+            Dictionary<int, int> dicCodeWork = new Dictionary<int, int>();
+
+            // トランザクション開始
+            ioInfo.beginTran();
+            ioPrgDate.beginTran();
+
+            string sql = "";
+
             try
             {
-                bool bUpdate = false;
+                foreach (int nConstructionCode in lstKeyInfo)
+                {
+                    int nOldStatus = 0;
+                    ConstructionBaseInfo Info = null;
 
-                string strSQL = cbDB.CreatePrimarykeyString(m_RequestNo);
-                ConstructionBaseInfo DataRec = new ConstructionBaseInfo();
-                if (!cbDB.SelectAction(strSQL, ref DataRec)) return false;
-                
-                // 進捗状態
-                if (radioButton1.Checked)
+                    // 工事基本情報の取得
+                    if (m_dicConstructionBaseInfo.TryGetValue(nConstructionCode, out Info) == false)
+                    {
+                        ioInfo.rollback();
+                        ioPrgDate.rollback();
+                        return false;
+                    }
+
+                    nOldStatus = Info.ConstructionStatusFlg;
+
+                    // 工事状態が「請求準備」ではない場合は、対象外
+                    if (nOldStatus != (int)CommonDefine.StatNumArray.Status9)
+                    {
+                        continue;
+                    }
+
+                    // 工事状態フラグを「請求完了」に変更
+                    Info.ConstructionStatusFlg = (int)CommonDefine.StatNumArray.Status10;
+
+                    // 工事基本情報を更新
+                    sql = ioInfo.CreatePrimarykeyString(nConstructionCode);
+                    if (ioInfo.UpdateAction(sql, Info) == false)
+                    {
+                        ioInfo.rollback();
+                        ioPrgDate.rollback();
+                        return false;
+                    }
+
+                    // 既にデータが存在しないか一度検索しておく
+                    sql = ioPrgDate.CreatePrimarykeyString(nConstructionCode, Info.ConstructionStatusFlg);
+                    List<ConstructionProgressDate> lstPrgDate = new List<ConstructionProgressDate>();
+                    if (ioPrgDate.SelectAction(sql, ref lstPrgDate) == false)
+                    {
+                        ioInfo.rollback();
+                        ioPrgDate.rollback();
+                        return false;
+                    }
+
+                    // データがある場合は、当該データを削除する
+                    if (lstPrgDate.Count > 0)
+                    {
+                        // 該当データを削除
+                        sql = ioPrgDate.CreatePrimarykeyString(nConstructionCode, Info.ConstructionStatusFlg);
+                        if (ioPrgDate.DeleteAction(sql) == false)
+                        {
+                            ioInfo.rollback();
+                            ioPrgDate.rollback();
+                            return false;
+                        }
+                    }
+
+                    // 案件進捗日付データの構築
+                    ConstructionProgressDate PrgDate = new ConstructionProgressDate();
+
+                    // 案件進捗日付データの設定
+                    PrgDate.ConstructionCode = nConstructionCode;
+                    PrgDate.ConstructionStatusFlg = (int)CommonDefine.StatNumArray.Status10;
+                    PrgDate.PreviousStatusFlg = nOldStatus;
+                    PrgDate.ChangeDate = DateTime.Now;
+                    PrgDate.ChangePersonCode = CommonMotions.LoginUserData.PersonCode;
+
+                    // 案件進捗日付データを挿入
+                    if (ioPrgDate.InsertAction(PrgDate) == false)
+                    {
+                        ioInfo.rollback();
+                        ioPrgDate.rollback();
+                        return false;
+                    }
+
+                    // 対象工事が結合（子）工事の場合
+                    if (Info.JoinFlg == (int)CommonDefine.BaseInfoJoinFlg.JoinChildren)
+                    {
+                        // 結合（親）工事番号の取得
+                        int nParentCode = GetJoinParentConstructionCode(nConstructionCode);
+
+                        int nChildCode = 0;
+
+                        // 親工事番号が登録されていない場合は登録する
+                        if (dicCodeWork.TryGetValue(nParentCode, out nChildCode) == false)
+                        {
+                            // 結合（親）の工事状態を更新するために工事番号を退避
+                            dicCodeWork.Add(nParentCode, nConstructionCode);
+                        }
+                    }
+
+                }
+
+                List<int> lstKeyLink = new List<int>(dicCodeWork.Keys);
+
+                foreach (int nParentCode in lstKeyLink)
                 {
-                    DataRec.ConstructionStatusFlg = m_ProgressStatus;
-                    bUpdate = true;
+                    int nChildCode = 0;
+
+                    if (dicCodeWork.TryGetValue(nParentCode, out nChildCode) == true)
+                    {
+                        // 結合（親）の工事状態を変更
+                        ClsChangeBaseInfoData.SetParentConstrStatus(ioInfo, nChildCode);
+                    }
                 }
 
-                // 変化なしは処理しない
-                if (!bUpdate) return true;
+                // DBコミット
+                ioInfo.commit();
+                ioPrgDate.commit();
 
-                if (!cbDB.UpdateAction(strSQL, DataRec)) return false;
-
+                return true;
             }
             catch (Exception ex)
             {
@@ -601,10 +940,11 @@
             }
             finally
             {
-                cbDB.close(); cbDB = null;
+                ioInfo.close(); 
+                ioInfo = null;
+                ioPrgDate.close();
+                ioPrgDate = null;
             }
-
-            return true;
         }
 
         #endregion
@@ -619,21 +959,21 @@
         /// <returns></returns>
         private bool GetRequestData(int constCode, ref RequestData data)
         {
-            var cbDB = new IORequestData();
+            //var cbDB = new IORequestData();
             try
             {
-                // 請求データ取得クラス領域
-                var wrk = new List<RequestData>();
+                //// 請求データ取得クラス領域
+                //var wrk = new List<RequestData>();
 
-                // 請求データ取得SQL
-                string strSQL = cbDB.CreateSubkeyString(constCode);
+                //// 請求データ取得SQL
+                //string strSQL = cbDB.CreateSubkeyString(constCode);
 
-                // 請求データ取得
-                if (!cbDB.SelectAction(strSQL, ref wrk)) return false;
+                //// 請求データ取得
+                //if (!cbDB.SelectAction(strSQL, ref wrk)) return false;
 
-                if (wrk.Count != 1) return false;
+                //if (wrk.Count != 1) return false;
 
-                data = wrk[0];
+                //data = wrk[0];
             }
             catch (Exception ex)
             {
@@ -642,7 +982,7 @@
             }
             finally
             {
-                cbDB.close(); cbDB = null;
+                //cbDB.close(); cbDB = null;
             }
 
             return true;
@@ -656,38 +996,38 @@
         /// <param name="requestNo"></param>
         /// <param name="datas"></param>
         /// <returns></returns>
-        private bool GetRequestTotalData(int requestNo, ref List<RequestTotalData> datas)
-        {
-            var cbDB = new IORequestTotalData();
-            try
-            {
-                // 請求書合計データ取得クラス領域
-                var wrk = new List<RequestTotalData>();
+        //private bool GetRequestTotalData(int requestNo, ref List<RequestTotalData> datas)
+        //{
+        //    var cbDB = new IORequestTotalData();
+        //    try
+        //    {
+        //        // 請求書合計データ取得クラス領域
+        //        var wrk = new List<RequestTotalData>();
 
-                // 請求書合計データ取得SQL
-                string strSQL = cbDB.CreatePrimarykeyString(requestNo);
+        //        // 請求書合計データ取得SQL
+        //        string strSQL = cbDB.CreatePrimarykeyString(requestNo);
 
-                // ソート条件追加
-                strSQL += " ORDER BY REQUESTNO, ORDERNO";
+        //        // ソート条件追加
+        //        strSQL += " ORDER BY REQUESTNO, ORDERNO";
 
-                // 請求書合計データ取得
-                if (!cbDB.SelectAction(strSQL, ref wrk)) return false;
+        //        // 請求書合計データ取得
+        //        if (!cbDB.SelectAction(strSQL, ref wrk)) return false;
 
-                // 請求書合計データ取得クラス領域
-                datas = wrk;
+        //        // 請求書合計データ取得クラス領域
+        //        datas = wrk;
 
-            }
-            catch (Exception ex)
-            {
-                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
-                return false;
-            }
-            finally
-            {
-                cbDB.close(); cbDB = null;
-            }
-            return true;
-        }
+        //    }
+        //    catch (Exception ex)
+        //    {
+        //        logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+        //        return false;
+        //    }
+        //    finally
+        //    {
+        //        cbDB.close(); cbDB = null;
+        //    }
+        //    return true;
+        //}
 
         #endregion
 
@@ -703,21 +1043,21 @@
             var cbDB = new IORequestDataDetail();
             try
             {
-                // 請求明細データ取得クラス領域
-                var wrk = new List<RequestDataDetail>();
+                //// 請求明細データ取得クラス領域
+                //var wrk = new List<RequestDataDetail>();
 
-                // 請求明細データ取得SQL
-                string strSQL = cbDB.CreatePrimarykeyString(requestNo);
+                //// 請求明細データ取得SQL
+                //string strSQL = cbDB.CreatePrimarykeyString(requestNo);
 
-                // 請求明細データ取得
-                if (!cbDB.SelectAction(strSQL, ref wrk)) return false;
+                //// 請求明細データ取得
+                //if (!cbDB.SelectAction(strSQL, ref wrk)) return false;
 
-                foreach (var record in wrk)
-                {
-                    if (!datas.ContainsKey(record.ConstructionCode))
-                        datas[record.ConstructionCode] = new Dictionary<int, RequestDataDetail>();
-                    datas[record.ConstructionCode][record.OrderNo] = record;
-                }
+                //foreach (var record in wrk)
+                //{
+                //    if (!datas.ContainsKey(record.ConstructionCode))
+                //        datas[record.ConstructionCode] = new Dictionary<int, RequestDataDetail>();
+                //    datas[record.ConstructionCode][record.OrderNo] = record;
+                //}
             }
             catch (Exception ex)
             {
@@ -770,6 +1110,43 @@
         }
         #endregion
 
+        #region 結合親工事番号の取得
+        private int GetJoinParentConstructionCode(int nConstructionCode)
+        {
+            int nParentCode = -1;
+            IOConstructionLink ioLink = new IOConstructionLink();
+
+            try
+            {
+                string sql = string.Format(" WHERE FluctuationCode = {0} AND LinkType = 1 ", nConstructionCode);
+                List<ConstructionLink> lstWork = new List<ConstructionLink>();
+
+                if (ioLink.SelectAction(sql, ref lstWork) == false)
+                {
+                    return nParentCode;
+                }
+
+                foreach (ConstructionLink Link in lstWork)
+                {
+                    nParentCode = Link.ConstructionCode;
+                    break;
+                }
+                return nParentCode;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return -1;
+            }
+            finally
+            {
+                ioLink.close(); 
+                ioLink = null;
+            }
+
+        }
+        #endregion
+
         #region 工事基本情報明細
         /// <summary>
         /// 工事基本情報明細を工事基本情報明細テーブルから工事番号をキーに取得する関数
